// Borland C++ Builder
// Copyright (c) 1995, 2005 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Idicmpclient.pas' rev: 10.00

#ifndef IdicmpclientHPP
#define IdicmpclientHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Idglobal.hpp>	// Pascal unit
#include <Idrawbase.hpp>	// Pascal unit
#include <Idrawclient.hpp>	// Pascal unit
#include <Idstack.hpp>	// Pascal unit
#include <Idstackconsts.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Idcomponent.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Idicmpclient
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TReplyStatusTypes { rsEcho, rsError, rsTimeOut, rsErrorUnreachable, rsErrorTTLExceeded };
#pragma option pop

struct TReplyStatus
{
	
public:
	int BytesReceived;
	AnsiString FromIpAddress;
	Byte MsgType;
	Word SequenceId;
	unsigned MsRoundTripTime;
	Byte TimeToLive;
	TReplyStatusTypes ReplyStatusType;
} ;

typedef char TCharBuf[1024];

typedef Byte TICMPDataBuffer[128];

typedef void __fastcall (__closure *TOnReplyEvent)(Classes::TComponent* ASender, const TReplyStatus &AReplyStatus);

class DELPHICLASS TIdIcmpClient;
class PASCALIMPLEMENTATION TIdIcmpClient : public Idrawclient::TIdRawClient 
{
	typedef Idrawclient::TIdRawClient inherited;
	
protected:
	char bufReceive[1024];
	char bufIcmp[1024];
	Word wSeqNo;
	int iDataSize;
	TReplyStatus FReplyStatus;
	TOnReplyEvent FOnReply;
	AnsiString FReplydata;
	Word __fastcall CalcCheckSum(void);
	bool __fastcall DecodeResponse(unsigned BytesRead, TReplyStatus &AReplyStatus);
	void __fastcall DoReply(const TReplyStatus &AReplyStatus);
	void __fastcall GetEchoReply(void);
	void __fastcall PrepareEchoRequest(AnsiString Buffer = "");
	void __fastcall SendEchoRequest(void);
	
public:
	__fastcall virtual TIdIcmpClient(Classes::TComponent* AOwner);
	void __fastcall Ping(AnsiString ABuffer = "", Word SequenceID = (Word)(0x0));
	TReplyStatus __fastcall Receive(int ATimeOut);
	__property TReplyStatus ReplyStatus = {read=FReplyStatus};
	__property AnsiString ReplyData = {read=FReplydata};
	
__published:
	__property ReceiveTimeout  = {default=5000};
	__property Host ;
	__property Port  = {default=0};
	__property Protocol  = {default=1};
	__property TOnReplyEvent OnReply = {read=FOnReply, write=FOnReply};
public:
	#pragma option push -w-inl
	/* TIdRawBase.Destroy */ inline __fastcall virtual ~TIdIcmpClient(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
static const Shortint DEF_PACKET_SIZE = 0x20;
static const Word MAX_PACKET_SIZE = 0x400;
static const Shortint ICMP_MIN = 0x8;
static const Byte iDEFAULTPACKETSIZE = 0x80;
static const Word iDEFAULTREPLYBUFSIZE = 0x400;
static const Word Id_TIDICMP_ReceiveTimeout = 0x1388;

}	/* namespace Idicmpclient */
using namespace Idicmpclient;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Idicmpclient
