// Borland C++ Builder
// Copyright (c) 1995, 2005 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Inthreadsafe.pas' rev: 10.00

#ifndef InthreadsafeHPP
#define InthreadsafeHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Inglobal.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Inthreadsafe
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TInThreadSafe;
class PASCALIMPLEMENTATION TInThreadSafe : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	Inglobal::TIdCriticalSection* FCriticalSection;
	
public:
	__fastcall virtual TInThreadSafe(void);
	__fastcall virtual ~TInThreadSafe(void);
	void __fastcall Lock(void);
	void __fastcall Unlock(void);
};


class DELPHICLASS TInThreadSafeInteger;
class PASCALIMPLEMENTATION TInThreadSafeInteger : public TInThreadSafe 
{
	typedef TInThreadSafe inherited;
	
protected:
	int FValue;
	int __fastcall GetValue(void);
	void __fastcall SetValue(const int AValue);
	
public:
	int __fastcall Decrement(void)/* overload */;
	int __fastcall Decrement(const int AValue)/* overload */;
	int __fastcall Increment(void)/* overload */;
	int __fastcall Increment(const int AValue)/* overload */;
	__property int Value = {read=GetValue, write=SetValue, nodefault};
public:
	#pragma option push -w-inl
	/* TInThreadSafe.Create */ inline __fastcall virtual TInThreadSafeInteger(void) : TInThreadSafe() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TInThreadSafe.Destroy */ inline __fastcall virtual ~TInThreadSafeInteger(void) { }
	#pragma option pop
	
};


class DELPHICLASS TInThreadSafeBoolean;
class PASCALIMPLEMENTATION TInThreadSafeBoolean : public TInThreadSafe 
{
	typedef TInThreadSafe inherited;
	
protected:
	bool FValue;
	bool __fastcall GetValue(void);
	void __fastcall SetValue(const bool AValue);
	
public:
	bool __fastcall Toggle(void);
	__property bool Value = {read=GetValue, write=SetValue, nodefault};
public:
	#pragma option push -w-inl
	/* TInThreadSafe.Create */ inline __fastcall virtual TInThreadSafeBoolean(void) : TInThreadSafe() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TInThreadSafe.Destroy */ inline __fastcall virtual ~TInThreadSafeBoolean(void) { }
	#pragma option pop
	
};


class DELPHICLASS TInThreadSafeCardinal;
class PASCALIMPLEMENTATION TInThreadSafeCardinal : public TInThreadSafe 
{
	typedef TInThreadSafe inherited;
	
protected:
	unsigned FValue;
	unsigned __fastcall GetValue(void);
	void __fastcall SetValue(const unsigned AValue);
	
public:
	unsigned __fastcall Decrement(void)/* overload */;
	unsigned __fastcall Decrement(const unsigned AValue)/* overload */;
	unsigned __fastcall Increment(void)/* overload */;
	unsigned __fastcall Increment(const unsigned AValue)/* overload */;
	__property unsigned Value = {read=GetValue, write=SetValue, nodefault};
public:
	#pragma option push -w-inl
	/* TInThreadSafe.Create */ inline __fastcall virtual TInThreadSafeCardinal(void) : TInThreadSafe() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TInThreadSafe.Destroy */ inline __fastcall virtual ~TInThreadSafeCardinal(void) { }
	#pragma option pop
	
};


class DELPHICLASS TInThreadSafeInt64;
class PASCALIMPLEMENTATION TInThreadSafeInt64 : public TInThreadSafe 
{
	typedef TInThreadSafe inherited;
	
protected:
	__int64 FValue;
	__int64 __fastcall GetValue(void);
	void __fastcall SetValue(const __int64 AValue);
	
public:
	__int64 __fastcall Decrement(void)/* overload */;
	__int64 __fastcall Decrement(const __int64 AValue)/* overload */;
	__int64 __fastcall Increment(void)/* overload */;
	__int64 __fastcall Increment(const __int64 AValue)/* overload */;
	__property __int64 Value = {read=GetValue, write=SetValue};
public:
	#pragma option push -w-inl
	/* TInThreadSafe.Create */ inline __fastcall virtual TInThreadSafeInt64(void) : TInThreadSafe() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TInThreadSafe.Destroy */ inline __fastcall virtual ~TInThreadSafeInt64(void) { }
	#pragma option pop
	
};


class DELPHICLASS TInThreadSafeString;
class PASCALIMPLEMENTATION TInThreadSafeString : public TInThreadSafe 
{
	typedef TInThreadSafe inherited;
	
protected:
	AnsiString FValue;
	AnsiString __fastcall GetValue();
	void __fastcall SetValue(const AnsiString AValue);
	
public:
	void __fastcall Append(const AnsiString AValue);
	void __fastcall Prepend(const AnsiString AValue);
	__property AnsiString Value = {read=GetValue, write=SetValue};
public:
	#pragma option push -w-inl
	/* TInThreadSafe.Create */ inline __fastcall virtual TInThreadSafeString(void) : TInThreadSafe() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TInThreadSafe.Destroy */ inline __fastcall virtual ~TInThreadSafeString(void) { }
	#pragma option pop
	
};


class DELPHICLASS TInThreadSafeStringList;
class PASCALIMPLEMENTATION TInThreadSafeStringList : public TInThreadSafe 
{
	typedef TInThreadSafe inherited;
	
protected:
	Classes::TStringList* FValue;
	AnsiString __fastcall GetValue(const AnsiString AName);
	void __fastcall SetValue(const AnsiString AName, const AnsiString AValue);
	
public:
	__fastcall TInThreadSafeStringList(const bool ASorted);
	__fastcall virtual ~TInThreadSafeStringList(void);
	void __fastcall Add(const AnsiString AItem);
	void __fastcall AddObject(const AnsiString AItem, System::TObject* AObject);
	void __fastcall Clear(void);
	bool __fastcall Empty(void);
	HIDESBASE Classes::TStringList* __fastcall Lock(void);
	System::TObject* __fastcall ObjectByItem(const AnsiString AItem);
	void __fastcall Remove(const AnsiString AItem);
	HIDESBASE void __fastcall Unlock(void);
	__property AnsiString Values[AnsiString AName] = {read=GetValue, write=SetValue};
};


class DELPHICLASS TInThreadSafeDateTime;
class PASCALIMPLEMENTATION TInThreadSafeDateTime : public TInThreadSafe 
{
	typedef TInThreadSafe inherited;
	
protected:
	System::TDateTime FValue;
	System::TDateTime __fastcall GetValue(void);
	void __fastcall SetValue(const System::TDateTime AValue);
	
public:
	void __fastcall Add(const System::TDateTime AValue);
	void __fastcall Subtract(const System::TDateTime AValue);
	__property System::TDateTime Value = {read=GetValue, write=SetValue};
public:
	#pragma option push -w-inl
	/* TInThreadSafe.Create */ inline __fastcall virtual TInThreadSafeDateTime(void) : TInThreadSafe() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TInThreadSafe.Destroy */ inline __fastcall virtual ~TInThreadSafeDateTime(void) { }
	#pragma option pop
	
};


class DELPHICLASS TInThreadSafeDouble;
class PASCALIMPLEMENTATION TInThreadSafeDouble : public TInThreadSafe 
{
	typedef TInThreadSafe inherited;
	
protected:
	double FValue;
	double __fastcall GetValue(void);
	void __fastcall SetValue(const double AValue);
	
public:
	void __fastcall Add(const double AValue);
	void __fastcall Subtract(const double AValue);
	__property double Value = {read=GetValue, write=SetValue};
public:
	#pragma option push -w-inl
	/* TInThreadSafe.Create */ inline __fastcall virtual TInThreadSafeDouble(void) : TInThreadSafe() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TInThreadSafe.Destroy */ inline __fastcall virtual ~TInThreadSafeDouble(void) { }
	#pragma option pop
	
};


class DELPHICLASS TInThreadSafeList;
class PASCALIMPLEMENTATION TInThreadSafeList : public Classes::TThreadList 
{
	typedef Classes::TThreadList inherited;
	
public:
	void __fastcall Assign(Classes::TThreadList* AThreadList)/* overload */;
	void __fastcall Assign(Classes::TList* AList)/* overload */;
	__fastcall virtual TInThreadSafeList(void);
	bool __fastcall IsCountLessThan(const unsigned AValue);
	bool __fastcall IsEmpty(void);
	System::TObject* __fastcall Pop(void);
	System::TObject* __fastcall Pull(void);
public:
	#pragma option push -w-inl
	/* TThreadList.Destroy */ inline __fastcall virtual ~TInThreadSafeList(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Inthreadsafe */
using namespace Inthreadsafe;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Inthreadsafe
