// Borland C++ Builder
// Copyright (c) 1995, 2005 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Propertycategories.pas' rev: 10.00

#ifndef PropertycategoriesHPP
#define PropertycategoriesHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Typinfo.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Masks.hpp>	// Pascal unit
#include <Contnrs.hpp>	// Pascal unit
#include <Designintf.hpp>	// Pascal unit
#include <Designeditors.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Propertycategories
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TPropertyFilter;
class PASCALIMPLEMENTATION TPropertyFilter : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Masks::TMask* FMask;
	int FGroup;
	
public:
	__fastcall TPropertyFilter(const AnsiString APropertyName, int AGroup);
	__fastcall virtual ~TPropertyFilter(void);
	virtual bool __fastcall Match(const AnsiString APropertyName, const Designintf::_di_IDesignObject DesignObject, const Designintf::_di_IProperty AProperty = (void *)(0x0))/* overload */;
};


class DELPHICLASS TComponentPropertyFilter;
class PASCALIMPLEMENTATION TComponentPropertyFilter : public TPropertyFilter 
{
	typedef TPropertyFilter inherited;
	
private:
	TMetaClass* FComponentClass;
	Typinfo::TTypeInfo *FPropertyType;
	
public:
	__fastcall TComponentPropertyFilter(const AnsiString APropertyName, TMetaClass* AComponentClass, Typinfo::PTypeInfo APropertyType);
	virtual bool __fastcall Match(const AnsiString APropertyName, const Designintf::_di_IDesignObject DesignObject, const Designintf::_di_IProperty AProperty = (void *)(0x0))/* overload */;
	HIDESBASE bool __fastcall Match(const AnsiString APropertyName, TMetaClass* AComponentClass, Typinfo::PTypeInfo APropertyType)/* overload */;
	__property TMetaClass* ComponentClass = {read=FComponentClass};
	__property Typinfo::PTypeInfo PropertyType = {read=FPropertyType};
public:
	#pragma option push -w-inl
	/* TPropertyFilter.Destroy */ inline __fastcall virtual ~TComponentPropertyFilter(void) { }
	#pragma option pop
	
};


class DELPHICLASS TPropertyCategory;
class PASCALIMPLEMENTATION TPropertyCategory : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Contnrs::TObjectList* FList;
	int FMatchCount;
	Designeditors::TPropertyEditor* FEditor;
	bool FEnabled;
	int FGroup;
	AnsiString FName;
	bool FVisible;
	
protected:
	TPropertyFilter* __fastcall GetFilter(int Index);
	
public:
	__fastcall TPropertyCategory(const AnsiString AName);
	__fastcall virtual ~TPropertyCategory(void);
	TPropertyFilter* __fastcall Add(TPropertyFilter* AFilter);
	void __fastcall Remove(TPropertyFilter* AFilter);
	int __fastcall Count(void);
	bool __fastcall Match(const AnsiString APropertyName, const Designintf::_di_IDesignObject DesignObject, const Designintf::_di_IProperty AProperty = (void *)(0x0))/* overload */;
	bool __fastcall Match(const AnsiString APropertyName, TMetaClass* AComponentClass, Typinfo::PTypeInfo APropertyType)/* overload */;
	void __fastcall ClearMatches(void);
	void __fastcall FreeEditorGroup(int AGroup);
	__property TPropertyFilter* Filters[int Index] = {read=GetFilter};
	__property int MatchCount = {read=FMatchCount, nodefault};
	__property bool Visible = {read=FVisible, write=FVisible, nodefault};
	__property Designeditors::TPropertyEditor* Editor = {read=FEditor, write=FEditor};
	__property AnsiString Name = {read=FName};
};


typedef TMetaClass* TPropertyCategoryClass;

#pragma option push -b-
enum TPropertyCategoryVisibleMode { pcvAll, pcvToggle, pcvNone, pcvNotListed, pcvOnlyListed };
#pragma option pop

class DELPHICLASS TPropertyCategoryList;
class PASCALIMPLEMENTATION TPropertyCategoryList : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	TPropertyCategory* operator[](int Index) { return Categories[Index]; }
	
private:
	Contnrs::TObjectList* FList;
	TPropertyCategory* FMiscCategory;
	Classes::TStringList* FHiddenCategories;
	
protected:
	TPropertyCategory* __fastcall GetCategory(int Index);
	
public:
	__fastcall TPropertyCategoryList(void);
	__fastcall virtual ~TPropertyCategoryList(void);
	TPropertyCategory* __fastcall FindCategory(const AnsiString ACategoryName);
	int __fastcall IndexOf(const AnsiString ACategoryName);
	void __fastcall ClearMatches(void);
	void __fastcall FreeEditorGroup(int AGroup);
	TPropertyCategory* __fastcall MiscCategory(void);
	int __fastcall Count(void);
	bool __fastcall Match(const AnsiString APropertyName, const Designintf::_di_IDesignObject DesignObject, const Designintf::_di_IProperty AProperty = (void *)(0x0))/* overload */;
	bool __fastcall Match(const AnsiString APropertyName, TMetaClass* AComponentClass, Typinfo::PTypeInfo APropertyType = (void *)(0x0))/* overload */;
	bool __fastcall ChangeVisibility(TPropertyCategoryVisibleMode AMode)/* overload */;
	bool __fastcall ChangeVisibility(TPropertyCategoryVisibleMode AMode, AnsiString const * ANames, const int ANames_Size)/* overload */;
	__property TPropertyCategory* Categories[int Index] = {read=GetCategory/*, default*/};
	void __fastcall LoadHiddenCategories(void);
	void __fastcall SaveHiddenCategories(void);
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE AnsiString __fastcall (*GetHiddenCategoriesProc)(void);
extern PACKAGE void __fastcall (*SetHiddenCategoriesProc)(const AnsiString Value);
extern PACKAGE bool __fastcall IsPropertyInCategory(const AnsiString Category, TMetaClass* ComponentClass, const AnsiString PropertyName)/* overload */;
extern PACKAGE bool __fastcall IsPropertyInCategory(const AnsiString Category, const AnsiString ClassName, const AnsiString PropertyName)/* overload */;
extern PACKAGE TPropertyCategoryList* __fastcall PropertyCategoryList(void);

}	/* namespace Propertycategories */
using namespace Propertycategories;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Propertycategories
